require("defines")

data:extend(
{
	-- Turret 1: recipe.
	{
		type = "recipe",
		name = supportive_turrets_defines.names.recipes.supportive_turret_1,
		ingredients = {},
		result = supportive_turrets_defines.names.items.supportive_turret_1
	},
	
	-- Turret 1: item.
	{
		type = "item",
		name = supportive_turrets_defines.names.items.supportive_turret_1,
		icon = "__base__/graphics/icons/laser-turret.png",
		flags = {"goes-to-quickbar"},
		place_result = supportive_turrets_defines.names.entities.supportive_turret_1,
		stack_size = 50
	},
	
	-- Turret 1: entity.
	{
		type = "electric-turret",
		name = supportive_turrets_defines.names.entities.supportive_turret_1,
		icon = "__base__/graphics/icons/laser-turret.png",
		flags = { "placeable-player", "placeable-enemy", "player-creation"},
		minable = { mining_time = 0.5, result = supportive_turrets_defines.names.items.supportive_turret_1 },
		max_health = 1000,
		corpse = "medium-remnants",
		collision_box = {{ -0.7, -0.7}, {0.7, 0.7}},
		selection_box = {{ -1, -1}, {1, 1}},
		rotation_speed = 0.01,
		preparing_speed = 0.05,
		dying_explosion = "medium-explosion",
		folding_speed = 0.05,
		energy_source =
		{
			type = "electric",
			buffer_capacity = "801kJ",
			input_flow_limit = "9600kW",
			drain = "24kW",
			usage_priority = "primary-input"
		},
		folded_animation =
		{
			layers =
			{
				laser_turret_extension{frame_count=1, line_length = 1},
				laser_turret_extension_shadow{frame_count=1, line_length=1},
				laser_turret_extension_mask{frame_count=1, line_length=1}
			}
		},
		preparing_animation =
		{
			layers =
			{
				laser_turret_extension{},
				laser_turret_extension_shadow{},
				laser_turret_extension_mask{}
			}
		},
		prepared_animation =
		{
			layers =
			{
				{
					filename = "__base__/graphics/entity/laser-turret/laser-turret-gun.png",
					line_length = 8,
					width = 68,
					height = 68,
					frame_count = 1,
					axially_symmetrical = false,
					direction_count = 64,
					shift = {0.0625, -1}
				},
				{
					filename = "__base__/graphics/entity/laser-turret/laser-turret-gun-mask.png",
					flags = { "mask" },
					line_length = 8,
					width = 54,
					height = 44,
					frame_count = 1,
					axially_symmetrical = false,
					apply_runtime_tint = true,
					direction_count = 64,
					shift = {0.0625, -1.3125},
				},
				{
					filename = "__base__/graphics/entity/laser-turret/laser-turret-gun-shadow.png",
					line_length = 8,
					width = 88,
					height = 52,
					frame_count = 1,
					axially_symmetrical = false,
					direction_count = 64,
					draw_as_shadow = true,
					shift = {1.59375, 0}
				}
			}
		},
		folding_animation = 
		{
			layers =
			{
				laser_turret_extension{run_mode = "backward"},
				laser_turret_extension_shadow{run_mode = "backward"},
				laser_turret_extension_mask{run_mode = "backward"}
			}
		},
		base_picture =
		{
			layers =
			{
				{
					filename = "__base__/graphics/entity/laser-turret/laser-turret-base.png",
					priority = "high",
					width = 98,
					height = 82,
					axially_symmetrical = false,
					direction_count = 1,
					frame_count = 1,
					shift = { 0.109375, 0.03125 }
				},
				{
					filename = "__base__/graphics/entity/laser-turret/laser-turret-base-mask.png",
					flags = { "mask" },
					line_length = 1,
					width = 54,
					height = 46,
					frame_count = 1,
					axially_symmetrical = false,
					apply_runtime_tint = true,
					direction_count = 1,
					frame_count = 1,
					shift = {0.046875, -0.109375},
				},
			}
		},
		vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },

		attack_parameters =
		{
			type = "projectile",
			ammo_category = "electric",
			cooldown = 0,
			projectile_center = {0, -0.2},
			projectile_creation_distance = 1.4,
			range = 25,
			damage_modifier = 0,
			ammo_type =
			{
				type = "none",
				category = "laser-turret"
			},
			sound = make_laser_sounds()
		},
		call_for_help_radius = 40
	},
	
	-- Turret 2: entity
	--[[
	{
		type = "electric-turret",
		name = supportive_turrets_defines.names.entities.supportive_turret_2,
		icon = "__base__/graphics/icons/laser-turret.png",
		flags = { "placeable-player", "placeable-enemy", "player-creation"},
		max_health = 1000,
		order = "a",
		corpse = "medium-remnants",
		collision_box = {{0, 0}, {0, 0}},
		selection_box = {{0, 0}, {0, 0}},
		rotation_speed = 0.01,
		preparing_speed = 0.05,
		dying_explosion = "medium-explosion",
		folding_speed = 0.05,
		energy_source =
		{
			type = "electric",
			buffer_capacity = "801kJ",
			input_flow_limit = "9600kW",
			drain = "24kW",
			usage_priority = "primary-input"
		},
		folded_animation = worm_folded_animation(medium_worm_scale, medium_worm_tint),
		prepare_range = 25,
		preparing_speed = 0.025,
		preparing_animation = worm_preparing_animation(medium_worm_scale, medium_worm_tint, "forward"),
		prepared_speed = 0.015,
		prepared_animation = worm_prepared_animation(medium_worm_scale, medium_worm_tint),
		starting_attack_speed = 0.03,
		starting_attack_animation = worm_attack_animation(medium_worm_scale, medium_worm_tint, "forward"),
		starting_attack_sound = make_worm_roars(0.8),
		ending_attack_speed = 0.03,
		ending_attack_animation = worm_attack_animation(medium_worm_scale, medium_worm_tint, "backward"),
		folding_speed = 0.015,
		folding_animation =  worm_preparing_animation(medium_worm_scale, medium_worm_tint, "backward"),
		prepare_range = 30,
		vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },

		attack_parameters =
		{
			type = "projectile",
			ammo_category = "electric",
			cooldown = 120,
			projectile_center = {0, -0.2},
			projectile_creation_distance = 1.4,
			range = 10,
			damage_modifier = 4,
			ammo_type =
			{
				type = "projectile",
				category = "laser-turret",
				energy_consumption = "800kJ",
				action =
				{
					type = "direct",
					action_delivery =
					{
						type = "instant",
						target_effects =
						{
							type = "create-entity",
							entity_name = supportive_turrets_defines.names.entities.reversed_poison_cloud
						}
					}
				}
			},
		},
		call_for_help_radius = 40
	},
	--]]
	
	-- Turret 1 - unit
	{
		type = "unit",
		name = supportive_turrets_defines.names.entities.supportive_turret_1_unit,
		order = "b-b-d",
		icon = "__base__/graphics/icons/behemoth-biter.png",
		flags = {"placeable-player", "placeable-enemy", "placeable-off-grid", "not-deconstructable"},
		max_health = 5000,
		subgroup = "enemies",
		resistances =
		{
			{
				type = "physical",
				decrease = 8,
				percent = 20
			},
			{
				type = "explosion",
				decrease = 10,
				percent = 20
			}
		},
		energy_source =
		{
			type = "electric",
			buffer_capacity = "801kJ",
			input_flow_limit = "9600kW",
			drain = "24kW",
			usage_priority = "primary-input"
		},
		spawning_time_modifier = 12,
		healing_per_tick = 0.1,
		collision_box = {{0, 0}, {0, 0}},
		selection_box = {{0, 0}, {0, 0}},
		sticker_box = {{0, 0}, {0, 0}},
		distraction_cooldown = 300,
		attack_parameters =
		{
			type = "projectile",
			ammo_category = "electric",
			cooldown = 120,
			projectile_center = {0, -0.2},
			projectile_creation_distance = 1.4,
			range = 10,
			damage_modifier = 4,
			ammo_type =
			{
				type = "projectile",
				category = "laser-turret",
				energy_consumption = "800kJ",
				action =
				{
					type = "direct",
					action_delivery =
					{
						type = "instant",
						target_effects =
						{
							type = "create-entity",
							entity_name = supportive_turrets_defines.names.entities.reversed_poison_cloud
						}
					}
				}
			},
			animation = biterattackanimation(behemothbiterscale, behemoth_biter_tint1, behemoth_biter_tint2)
		},
		vision_distance = 30,
		movement_speed = 0,
		distance_per_frame = 0,
		-- in pu
		pollution_to_join_attack = 0,
		corpse = "behemoth-biter-corpse",
		dying_explosion = "blood-explosion-big",
		working_sound = make_biter_calls(1.2),
		dying_sound = make_biter_dying_sounds(1.0),
		run_animation = biterrunanimation(behemothbiterscale, behemoth_biter_tint1, behemoth_biter_tint2)
	},
	
	
	
	
	
	-- Reversed poison cloud.
	{
		type = "smoke-with-trigger",
		name = supportive_turrets_defines.names.entities.reversed_poison_cloud,
		flags = {"not-on-map"},
		show_when_smoke_off = true,
		animation =
		{
			filename = "__base__/graphics/entity/cloud/cloud-45-frames.png",
			flags = { "compressed" },
			priority = "low",
			width = 256,
			height = 256,
			frame_count = 45,
			animation_speed = 0.5,
			line_length = 7,
			scale = 3,
			run_mode = "backward"
		},
		slow_down_factor = 0,
		affected_by_wind = false,
		cyclic = true,
		duration = 30,
		fade_away_duration = 30,
		spread_duration = 10,
		color = { r = 1, g = 1, b = 0.2 },
		action =
		{
			type = "direct",
			action_delivery =
			{
				type = "instant",
				target_effects =
				{
					type = "nested-result",
					action =
					{
						type = "area",
						perimeter = 11,
						force = "ally",
						--entity_flags = {"breaths-air"},
						action_delivery =
						{
							type = "instant",
							target_effects =
							{
								type = "damage",
								damage = { amount = -4, type = "poison"}
							}
						}
					}
				}
			}
		},
		action_frequency = 30
	},
})